(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs/add/observable/empty'), require('rxjs/add/observable/forkJoin'), require('rxjs/add/observable/fromEvent'), require('rxjs/add/observable/fromPromise'), require('rxjs/add/observable/interval'), require('rxjs/add/observable/of'), require('rxjs/add/operator/map'), require('rxjs/add/operator/mergeMap'), require('rxjs/add/operator/take'), require('rxjs/Observable'), require('rxjs/ReplaySubject')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'rxjs/add/observable/empty', 'rxjs/add/observable/forkJoin', 'rxjs/add/observable/fromEvent', 'rxjs/add/observable/fromPromise', 'rxjs/add/observable/interval', 'rxjs/add/observable/of', 'rxjs/add/operator/map', 'rxjs/add/operator/mergeMap', 'rxjs/add/operator/take', 'rxjs/Observable', 'rxjs/ReplaySubject'], factory) :
	(factory((global.ng = global.ng || {}, global.ng.fileinputaccessor = {}),global.ng.core,global.ng.forms,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable.prototype,global.Rx.Observable.prototype,null,global.Rx,global.Rx));
}(this, (function (exports,core,forms,empty,forkJoin,fromEvent,fromPromise,interval,of,map,mergeMap,take,Observable,ReplaySubject) { 'use strict';

var FileInputAccessor = (function () {
    function FileInputAccessor(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.onChange = function (_) {
        };
        this.onTouched = function () {
        };
        this.validator = this.generateAsyncValidator();
    }
    FileInputAccessor.prototype.ngOnChanges = function (changes) {
        if (changes.fileList && changes.fileList.currentValue.length == 0) {
            this._renderer.setProperty(this._elementRef.nativeElement, 'value', []);
        }
    };
    FileInputAccessor.prototype.writeValue = function (value) {
        var normalizedValue = value == null ? '' : value;
        this._renderer.setProperty(this._elementRef.nativeElement, 'value', normalizedValue);
    };
    FileInputAccessor.prototype.registerOnChange = function (fn) {
        this.onChange = this.onChangeGenerator(fn);
    };
    FileInputAccessor.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    FileInputAccessor.prototype.setDisabledState = function (isDisabled) {
        throw new Error("Method not implemented.");
    };
    FileInputAccessor.prototype.validate = function (c) {
        return this.validator(c);
    };
    FileInputAccessor.prototype.generateAsyncValidator = function () {
        var _this = this;
        return function (c) {
            if (!c.value || !c.value.length)
                return Observable.Observable.of({});
            var errors = {};
            var loaders = [];
            var _loop_1 = function (f) {
                if (_this.maxSize && _this.maxSize < f.size) {
                    f.errors['fileSize'] = true;
                    errors['fileSize'] = 'File size too large';
                }
                if (f.isImg && (_this.maxWidth || _this.maxHeight)) {
                    loaders.push(f.imgLoadReplay
                        .take(1)
                        .map(function (e) {
                        if (_this.maxWidth && f.imgWidth > _this.maxWidth) {
                            f.errors['imageWidth'] = true;
                            errors['imageWidth'] = 'Image is too wide';
                        }
                        if (_this.maxHeight && f.imgHeight > _this.maxHeight) {
                            f.errors['imageHeight'] = true;
                            errors['imageHeight'] = 'Image is too tall';
                        }
                        return e;
                    }));
                }
                if (!_this.extPattern && !_this.typePattern)
                    return "continue";
                var extP = _this.generateRegExp(_this.extPattern);
                var typeP = _this.generateRegExp(_this.typePattern);
                if ((extP && !extP.test(f.name)) || (typeP && !typeP.test(f.type))) {
                    f.errors['fileType'] = true;
                    errors['fileType'] = 'File type not allowed';
                }
            };
            for (var _i = 0, _a = c.value; _i < _a.length; _i++) {
                var f = _a[_i];
                _loop_1(f);
            }
            if (loaders.length) {
                return Observable.Observable
                    .forkJoin.apply(Observable.Observable, loaders).map(function (loadResults) {
                    return errors;
                });
            }
            return Observable.Observable.of(errors);
        };
    };
    
    FileInputAccessor.prototype.onChangeGenerator = function (fn) {
        var _this = this;
        return function (files) {
            var fileArr = [];
            if (!files || !files.length) {
                _this._renderer.setProperty(_this._elementRef.nativeElement, 'value', []);
                return fn(fileArr);
            }
            for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var f = files_1[_i];
                if (_this.addMeta && FileReader) {
                    var fr = new FileReader();
                    _this.generateFileMeta(f, fr);
                }
                f.errors = {};
                fileArr.push(f);
            }
            return fn(fileArr);
        };
    };
    
    FileInputAccessor.prototype.generateRegExp = function (pattern) {
        if (!pattern)
            return;
        if (pattern instanceof RegExp) {
            return new RegExp(pattern);
        }
        else if (typeof pattern === 'string') {
            return new RegExp(pattern, 'ig');
        }
        else if (pattern instanceof Array) {
            return new RegExp("(" + pattern.join('|') + ")", 'ig');
        }
    };
    FileInputAccessor.prototype.generateFileMeta = function (f, fr) {
        if (f.type.match(/text.*/)) {
            f.textLoadReplay = this.setText(f, fr);
        }
        else if (f.type.match(/image.*/)) {
            f.imgLoadReplay = this.setImage(f, fr);
        }
    };
    FileInputAccessor.prototype.setImage = function (f, fr) {
        f.isImg = true;
        var img = new Image();
        var imgLoadObs = Observable.Observable.fromEvent(img, 'load')
            .take(1)
            .map(function (e) {
            f.imgHeight = img.height;
            f.imgWidth = img.width;
            return e;
        });
        var frLoadObs = Observable.Observable.fromEvent(fr, 'load')
            .take(1)
            .map(function (e) {
            f.imgSrc = fr.result;
            img.src = fr.result;
            return e;
        });
        var onloadReplay = new ReplaySubject.ReplaySubject(1);
        Observable.Observable
            .forkJoin(imgLoadObs, frLoadObs)
            .subscribe(onloadReplay);
        fr.readAsDataURL(f);
        return onloadReplay;
    };
    FileInputAccessor.prototype.setText = function (f, fr) {
        var onloadReplay = new ReplaySubject.ReplaySubject(1);
        Observable.Observable.fromEvent(fr, 'load')
            .map(function (e) {
            f.textContent = fr.result;
            return [e];
        })
            .subscribe(onloadReplay);
        fr.readAsText(f);
        return onloadReplay;
    };
    return FileInputAccessor;
}());
FileInputAccessor.decorators = [
    { type: core.Directive, args: [{
                selector: 'input[type=file][formControl],input[type=file][formControlName],input[type=file][ngModel]',
                host: { '(change)': 'onChange($event.target.files)', '(blur)': 'onTouched()' },
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return FileInputAccessor; }),
                        multi: true
                    },
                    {
                        provide: forms.NG_ASYNC_VALIDATORS,
                        useExisting: core.forwardRef(function () { return FileInputAccessor; }),
                        multi: true
                    }
                ]
            },] },
];
/** @nocollapse */
FileInputAccessor.ctorParameters = function () { return [
    { type: core.Renderer2, },
    { type: core.ElementRef, },
]; };
FileInputAccessor.propDecorators = {
    'extPattern': [{ type: core.Input, args: ['allowedExt',] },],
    'typePattern': [{ type: core.Input, args: ['allowedTypes',] },],
    'maxSize': [{ type: core.Input, args: ['size',] },],
    'addMeta': [{ type: core.Input, args: ['withMeta',] },],
    'maxHeight': [{ type: core.Input, args: ['maxHeight',] },],
    'maxWidth': [{ type: core.Input, args: ['maxWidth',] },],
};

var FileInputAccessorModule = (function () {
    function FileInputAccessorModule() {
    }
    return FileInputAccessorModule;
}());
FileInputAccessorModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [FileInputAccessor],
                imports: [
                    forms.FormsModule,
                    forms.ReactiveFormsModule
                ],
                exports: [FileInputAccessor]
            },] },
];
/** @nocollapse */
FileInputAccessorModule.ctorParameters = function () { return []; };

exports.FileInputAccessor = FileInputAccessor;
exports.FileInputAccessorModule = FileInputAccessorModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
